#ifndef _H8S2623F_H_
#define _H8S2623F_H_

/***********************************************************************/
/*                                                                     */
/*             Definition of I/O Register  H8S/2623F                   */
/*                                                                     */
/***********************************************************************/
                  


/************************************************************************/
/*      H8S/2623 Series Include File                       Ver 1.1      */
/************************************************************************/
struct st_hcan {                                        /* struct HACN  */
               union {                                  /* MCR          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char SLPME:1;      /*    SLPME     */
                            unsigned char      :1;      /*              */
                            unsigned char SLPM :1;      /*    SLPM      */
                            unsigned char      :2;      /*              */
                            unsigned char MSM  :1;      /*    MSM       */
                            unsigned char HALT :1;      /*    HALT      */
                            unsigned char RST  :1;      /*    RST       */
                     }             Bit;                 /*              */
               }                MCR;                    /*              */
               union {                                  /* GSR          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :4;       /*              */
                            unsigned char RSF :1;       /*    RSF       */
                            unsigned char MSEF:1;       /*    MSEF      */
                            unsigned char SRWF:1;       /*    SRWF      */
                            unsigned char BOF :1;       /*    BOF       */
                     }             Bit;                 /*              */
               }                GSR;                    /*              */
               union {                                  /* BCR          */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char SJW:2;        /*    SJW       */
                            unsigned char BRP:6;        /*    BRP       */
                            unsigned char BSP:1;        /*    BSP       */
                            unsigned char TS2:3;        /*    TS2       */
                            unsigned char TS1:4;        /*    TS1       */
                     }              Bit;                /*              */
               }                BCR;                    /*              */
               union {                                  /* MBCR         */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                MBCR;                   /*              */
               union {                                  /* TXPR         */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                TXPR;                   /*              */
               union {                                  /* TXCR         */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                TXCR;                   /*              */
               union {                                  /* TXACK        */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                TXACK;                  /*              */
               union {                                  /* ABACK        */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                ABACK;                  /*              */
               union {                                  /* RXPR         */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char MB0 :1;       /*    MB0       */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                RXPR;                   /*              */
               union {                                  /* RFPR         */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char MB0 :1;       /*    MB0       */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                RFPR;                   /*              */
               union {                                  /* IRR          */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char OLFF:1;       /*    OLFF      */
                            unsigned char BOF :1;       /*    BOF       */
                            unsigned char EPF :1;       /*    EPF       */
                            unsigned char ROWF:1;       /*    ROWF      */
                            unsigned char SOWF:1;       /*    SOWF      */
                            unsigned char RFRF:1;       /*    RFRF      */
                            unsigned char RMF :1;       /*    RMF       */
                            unsigned char RSTF:1;       /*    RSTF      */
                            unsigned char     :3;       /*              */
                            unsigned char BSF :1;       /*    BSF       */
                            unsigned char     :2;       /*              */
                            unsigned char UMF :1;       /*    UMF       */
                            unsigned char MEF :1;       /*    MEF       */
                     }              Bit;                /*              */
               }                IRR;                    /*              */
               union {                                  /* MBIMR        */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char MB0 :1;       /*    MB0       */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                MBIMR;                  /*              */
               union {                                  /* IMR          */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char OLFIE:1;      /*    OLFIE     */
                            unsigned char BOIE :1;      /*    BOIE      */
                            unsigned char EPIE :1;      /*    EPIE      */
                            unsigned char ROWIE:1;      /*    ROWIE     */
                            unsigned char SOWIE:1;      /*    SOWIE     */
                            unsigned char RFRIE:1;      /*    RFRIE     */
                            unsigned char RMIE :1;      /*    RMIE      */
                            unsigned char      :1;      /*              */
                            unsigned char      :3;      /*              */
                            unsigned char BSIE :1;      /*    BSIE      */
                            unsigned char      :2;      /*              */
                            unsigned char UMIE :1;      /*    UMIE      */
                            unsigned char MEIE :1;      /*    MEIE      */
                     }              Bit;                /*              */
               }                IMR;                    /*              */
               unsigned char    REC;                    /* REC          */
               unsigned char    TEC;                    /* TEC          */
               union {                                  /* UMSR         */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char MB0 :1;       /*    MB0       */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                     }              Bit;                /*              */
               }                UMSR;                   /*              */
               union {                                  /* LAFML        */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char L;            /*    Low       */
                            unsigned char H;            /*    High      */
                            }       Byte;               /*              */
                     }          LAFML;                  /*              */
               union {                                  /* LAFMH        */
                     unsigned short Word;               /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char L;            /*    Low       */
                            unsigned char H;            /*    High      */
                            }       Byte;               /*              */
                     }          LAFMH;                  /*              */
               unsigned char    MC[16][8];              /* MC[x][y]     */
               char             wk1[16];                /*  --BUG--     */
               unsigned char    MD[16][8];              /* MD[x][y]     */
};                                                      /*              */
union un_scrx {                                         /* union SCRX   */
              unsigned char Byte;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     unsigned char wk   :4;             /*              */
                     unsigned char FLSHE:1;             /*    FLSHE     */
                     }      Bit;                        /*              */
};                                                      /*              */
union un_sbycr {                                        /* union SBYCR  */
               unsigned char Byte;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char SSBY:1;             /*    SSBY      */
                      unsigned char STS :3;             /*    STS       */
                      unsigned char OPE :1;             /*    OPE       */
                      }      Bit;                       /*              */
};                                                      /*              */
union un_syscr {                                        /* union SYSCR  */
               unsigned char Byte;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char MACS :1;            /*    MACS      */
                      unsigned char      :1;            /*              */
                      unsigned char INTM :2;            /*    INTM      */
                      unsigned char NMIEG:1;            /*    NMIEG     */
                      unsigned char MRESE:1;            /*    MRESE     */
                      unsigned char      :1;            /*              */
                      unsigned char RAME :1;            /*    RAME      */
                      }      Bit;                       /*              */
};                                                      /*              */
union un_sckcr {                                        /* union SCKCR  */
               unsigned char Byte;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char PSTOP:1;            /*    SSBY      */
                      unsigned char      :3;            /*              */
                      unsigned char STCS :1;            /*    STCS      */
                      unsigned char SCK  :3;            /*    SCK       */
                      }      Bit;                       /*              */
};                                                      /*              */
union un_mdcr {                                         /* union MDCR   */
              unsigned char Byte;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     unsigned char wk :5;               /*              */
                     unsigned char MDS:3;               /*    MDS       */
                     }      Bit;                        /*              */
};                                                      /*              */
struct st_mstp {                                        /* struct MSTP  */
               union {                                  /* CRA          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char :1;           /*              */
                            unsigned char DisableDTC:1;        /* Data transfer controller (DTC)     */
                            unsigned char DisableTPU:1;        /* 16-bit timer pulse unit (TPU)      */
                            unsigned char :1;           /*              */
                            unsigned char DisablePPG:1;        /* Programmable pulse generator (PPG) */
                            unsigned char :1;           /*              */
                            unsigned char DisableADC:1;        /* A/D converter       */
                     }             Bit;                 /*              */
               }                CRA;                    /*              */
               union {                                  /* CRB          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char DisableSCI0:1;       /*    SCI0      */
                            unsigned char DisableSCI1:1;       /*    SCI1      */
                            unsigned char DisableSCI2:1;       /*    SCI2      */
                     }             Bit;                 /*              */
               }                CRB;                    /*              */
               union {                                  /* CRC          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char :3;	        /*              */
                            unsigned char DisablePBC:1;        /*  PC break controller (PBC)   */
                            unsigned char DisableHCAN:1;       /*  HCAN      */
                     }             Bit;                 /*              */
               }                CRC;                    /*              */
};                                                      /*              */
union un_lpwrcr {                                       /* union LPWRCR */
                unsigned char Byte;                     /*  Byte Access */
                struct {                                /*  Bit  Access */
                       unsigned char wk :6;             /*              */
                       unsigned char STC:2;             /*    STC       */
                       }      Bit;                      /*              */
};                                                      /*              */
struct st_pbc {                                         /* struct PBC   */
              void             *BARA;                   /* BARA         */
              void             *BARB;                   /* BARB         */
              union {                                   /* BCRA         */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMF :1;        /*    CMF       */
                           unsigned char CD  :1;        /*    CD        */
                           unsigned char BAMR:3;        /*    BAMR      */
                           unsigned char CSEL:2;        /*    CSEL      */
                           unsigned char BIE :1;        /*    BIE       */
                           }      Bit;                  /*              */
                    }           BCRA;                   /*              */
              union {                                   /* BCRB         */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMF :1;        /*    CMF       */
                           unsigned char CD  :1;        /*    CD        */
                           unsigned char BAMR:3;        /*    BAMR      */
                           unsigned char CSEL:2;        /*    CSEL      */
                           unsigned char BIE :1;        /*    BIE       */
                           }      Bit;                  /*              */
                    }           BCRB;                   /*              */
};                                                      /*              */
struct st_dtc {                                         /* struct DTC   */
              union {                                   /* EA           */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B7:1;          /*    IRQ0      */
                           unsigned char B6:1;          /*    IRQ1      */
                           unsigned char B5:1;          /*    IRQ2      */
                           unsigned char B4:1;          /*    IRQ3      */
                           unsigned char B3:1;          /*    IRQ4      */
                           unsigned char B2:1;          /*    IRQ5      */
                           unsigned char B1:1;          /*    IRQ6      */
                           unsigned char B0:1;          /*    IRQ7      */
                           }      Bit;                  /*              */
                    }           EA;                     /*              */
              union {                                   /* EB           */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk:1;          /*              */
                           unsigned char B6:1;          /*    ADI       */
                           unsigned char B5:1;          /*    TGI0A     */
                           unsigned char B4:1;          /*    TGI0B     */
                           unsigned char B3:1;          /*    TGI0C     */
                           unsigned char B2:1;          /*    TGI0D     */
                           unsigned char B1:1;          /*    TGI1A     */
                           unsigned char B0:1;          /*    TGI1B     */
                           }      Bit;                  /*              */
                    }           EB;                     /*              */
              union {                                   /* EC           */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B7:1;          /*    TGI2A     */
                           unsigned char B6:1;          /*    TGI2B     */
                           unsigned char B5:1;          /*    TGI3A     */
                           unsigned char B4:1;          /*    TGI3B     */
                           unsigned char B3:1;          /*    TGI3C     */
                           unsigned char B2:1;          /*    TGI3D     */
                           unsigned char B1:1;          /*    TGI4A     */
                           unsigned char B0:1;          /*    TGI4B     */
                           }      Bit;                  /*              */
                    }           EC;                     /*              */
              union {                                   /* ED           */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk:2;          /*              */
                           unsigned char B5:1;          /*    TGI5A     */
                           unsigned char B4:1;          /*    TGI5B     */
                           }      Bit;                  /*              */
                    }           ED;                     /*              */
              union {                                   /* EE           */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk:4;          /*              */
                           unsigned char B3:1;          /*    RXI0      */
                           unsigned char B2:1;          /*    TXI0      */
                           unsigned char B1:1;          /*    RXI1      */
                           unsigned char B0:1;          /*    TXI1      */
                           }      Bit;                  /*              */
                    }           EE;                     /*              */
              union {                                   /* EF           */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B7:1;          /*    RXI2      */
                           unsigned char B6:1;          /*    TXI2      */
                           }      Bit;                  /*              */
                    }           EF;                     /*              */
              union {                                   /* EG           */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk:2;          /*              */
                           unsigned char B5:1;          /*    RM0       */
                           }      Bit;                  /*              */
                    }           EG;                     /*              */
              char              wk[2];                  /*              */
              union {                                   /* VECR         */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char SWDTE:1;       /*    SWDTE     */
                           unsigned char DTVEC:7;       /*    DTVEC     */
                           }      Bit;                  /*              */
                    }           VECR;                   /*              */
};                                                      /*              */
struct st_ppg {                                         /* struct PPG   */
              union {                                   /* PCR          */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char G3CMS:2;       /*    G3CMS     */
                           unsigned char G2CMS:2;       /*    G2CMS     */
                           unsigned char G1CMS:2;       /*    G1CMS     */
                           unsigned char G0CMS:2;       /*    G0CMS     */
                           }      Bit;                  /*              */
                    }           PCR;                    /*              */
              union {                                   /* PMR          */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char G3INV:1;       /*    G3INV     */
                           unsigned char G2INV:1;       /*    G2INV     */
                           unsigned char G1INV:1;       /*    G1INV     */
                           unsigned char G0INV:1;       /*    G0INV     */
                           unsigned char G3NOV:1;       /*    G3NOV     */
                           unsigned char G2NOV:1;       /*    G2NOV     */
                           unsigned char G1NOV:1;       /*    G1NOV     */
                           unsigned char G0NOV:1;       /*    G0NOV     */
                           }      Bit;                  /*              */
                    }           PMR;                    /*              */
              union {                                   /* NDER         */
                    unsigned int Word;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char H;             /*    NDERH     */
                           unsigned char L;             /*    NDERL     */
                           }     Byte;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDER15    */
                           unsigned char B14:1;         /*    NDER14    */
                           unsigned char B13:1;         /*    NDER13    */
                           unsigned char B12:1;         /*    NDER12    */
                           unsigned char B11:1;         /*    NDER11    */
                           unsigned char B10:1;         /*    NDER10    */
                           unsigned char B9 :1;         /*    NDER9     */
                           unsigned char B8 :1;         /*    NDER8     */
                           unsigned char B7 :1;         /*    NDER7     */
                           unsigned char B6 :1;         /*    NDER6     */
                           unsigned char B5 :1;         /*    NDER5     */
                           unsigned char B4 :1;         /*    NDER4     */
                           unsigned char B3 :1;         /*    NDER3     */
                           unsigned char B2 :1;         /*    NDER2     */
                           unsigned char B1 :1;         /*    NDER1     */
                           unsigned char B0 :1;         /*    NDER0     */
                           }      Bit;                  /*              */
                    }           NDER;                   /*              */
              union {                                   /* PODR         */
                    unsigned int Word;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char H;             /*    PODRH     */
                           unsigned char L;             /*    PODRL     */
                           }     Byte;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDER15    */
                           unsigned char B14:1;         /*    NDER14    */
                           unsigned char B13:1;         /*    NDER13    */
                           unsigned char B12:1;         /*    NDER12    */
                           unsigned char B11:1;         /*    NDER11    */
                           unsigned char B10:1;         /*    NDER10    */
                           unsigned char B9 :1;         /*    NDER9     */
                           unsigned char B8 :1;         /*    NDER8     */
                           unsigned char B7 :1;         /*    NDER7     */
                           unsigned char B6 :1;         /*    NDER6     */
                           unsigned char B5 :1;         /*    NDER5     */
                           unsigned char B4 :1;         /*    NDER4     */
                           unsigned char B3 :1;         /*    NDER3     */
                           unsigned char B2 :1;         /*    NDER2     */
                           unsigned char B1 :1;         /*    NDER1     */
                           unsigned char B0 :1;         /*    NDER0     */
                           }     Bit;                   /*              */
                    }           PODR;                   /*              */
              union {                                   /* NDRH (H'2C)  */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDR15     */
                           unsigned char B14:1;         /*    NDR14     */
                           unsigned char B13:1;         /*    NDR13     */
                           unsigned char B12:1;         /*    NDR12     */
                           unsigned char B11:1;         /*    NDR11     */
                           unsigned char B10:1;         /*    NDR10     */
                           unsigned char B9 :1;         /*    NDR9      */
                           unsigned char B8 :1;         /*    NDR8      */
                           }      Bit;                  /*              */
                    }           NDRH1;                  /*              */
              union {                                   /* NDRL (H'2D)  */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B7:1;          /*    NDR7      */
                           unsigned char B6:1;          /*    NDR6      */
                           unsigned char B5:1;          /*    NDR5      */
                           unsigned char B4:1;          /*    NDR4      */
                           unsigned char B3:1;          /*    NDR3      */
                           unsigned char B2:1;          /*    NDR2      */
                           unsigned char B1:1;          /*    NDR1      */
                           unsigned char B0:1;          /*    NDR0      */
                           }      Bit;                  /*              */
                    }           NDRL1;                  /*              */
              union {                                   /* NDRH (H'2E)  */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk :4;         /*              */
                           unsigned char B11:1;         /*    NDR11     */
                           unsigned char B10:1;         /*    NDR10     */
                           unsigned char B9 :1;         /*    NDR9      */
                           unsigned char B8 :1;         /*    NDR8      */
                           }      Bit;                  /*              */
                    }           NDRH2;                  /*              */
              union {                                   /* NDRL (H'2F)  */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk:4;          /*              */
                           unsigned char B3:1;          /*    NDR3      */
                           unsigned char B2:1;          /*    NDR2      */
                           unsigned char B1:1;          /*    NDR1      */
                           unsigned char B0:1;          /*    NDR0      */
                           }      Bit;                  /*              */
                    }           NDRL2;                  /*              */
};                                                      /*              */
struct st_p1 {                                          /* struct P1    */
             unsigned char      DDR;                    /* P1DDR        */
             char               wk1[207];               /*              */
             union {                                    /* P1DR         */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            DR;                     /*              */
             char               wk2[175];               /*              */
             union {                                    /* P1PORT       */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_p4 {                                          /* struct P4    */
             union {                                    /* P4PORT       */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pa {                                          /* struct PA    */
             unsigned char      DDR;                    /* PADDR        */
             char               wk1[6];                 /*              */
             union {                                    /* PAPCR        */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char wk:2;           /*              */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[5];                 /* --BUG--      */
             union {                                    /* PAODR        */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char wk:2;           /*              */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            ODR;                    /*              */
             char               wk3[194];               /*  --BUG--     */
             union {                                    /* PADR         */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char wk:2;           /*              */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            DR;                     /*              */
             char               wk4[175];               /*              */
             union {                                    /* PAPORT       */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char wk:2;           /*              */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pb {                                          /* struct PB    */
             unsigned char      DDR;                    /* PBDDR        */
             char               wk1[6];                 /*              */
             union {                                    /* PBPCR        */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[5];                 /*   --BUG--    */
             union {                                    /* PBODR        */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            ODR;                    /*              */
             char               wk3[194];               /*   --BUG--    */
             union {                                    /* PBDR         */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            DR;                     /*              */
             char               wk4[175];               /*              */
             union {                                    /* PBPORT       */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pd {                                          /* struct PD    */
             unsigned char      DDR;                    /* PDDDR        */
             char               wk1[6];                 /*              */
             union {                                    /* PDPCR        */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[200];                /*             */
             union {                                    /* PDDR         */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            DR;                     /*              */
             char               wk3[175];               /*              */
             union {                                    /* PDPORT       */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      Bit;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_tpu {                                         /* struct TPU   */
              union {                                   /* TSTR         */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk  :2;        /*              */
                           unsigned char CST5:1;        /*    CST5      */
                           unsigned char CST4:1;        /*    CST4      */
                           unsigned char CST3:1;        /*    CST3      */
                           unsigned char CST2:1;        /*    CST2      */
                           unsigned char CST1:1;        /*    CST1      */
                           unsigned char CST0:1;        /*    CST0      */
                           }      Bit;                  /*              */
                    }           TSTR;                   /*              */
              union {                                   /* TSYR         */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk   :2;       /*              */
                           unsigned char SYNC5:1;       /*    SYNC5     */
                           unsigned char SYNC4:1;       /*    SYNC4     */
                           unsigned char SYNC3:1;       /*    SYNC3     */
                           unsigned char SYNC2:1;       /*    SYNC2     */
                           unsigned char SYNC1:1;       /*    SYNC1     */
                           unsigned char SYNC0:1;       /*    SYNC0     */
                           }      Bit;                  /*              */
                    }           TSYR;                   /*              */
};                                                      /*              */
struct st_tpu0 {                                        /* struct TPU0  */
               union {                                  /* TCR          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CCLR:3;       /*    CCLR      */
                            unsigned char CKEG:2;       /*    CKEG      */
                            unsigned char TPSC:3;       /*    TPSC      */
                            }      Bit;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TMDR         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk :2;        /*              */
                            unsigned char BFB:1;        /*    BFB       */
                            unsigned char BFA:1;        /*    BFA       */
                            unsigned char MD :4;        /*    MD        */
                            }      Bit;                 /*              */
                     }          TMDR;                   /*              */
               union {                                  /* TIOR         */
                     unsigned int Word;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char H;            /*    TIORH     */
                            unsigned char L;            /*    TIORL     */
                            }     Byte;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char IOB:4;        /*    IOB       */
                            unsigned char IOA:4;        /*    IOA       */
                            unsigned char IOD:4;        /*    IOD       */
                            unsigned char IOC:4;        /*    IOC       */
                            }     Bit;                  /*              */
                     }          TIOR;                   /*              */
               union {                                  /* TIER         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TTGE :1;      /*    TTGE      */
                            unsigned char      :2;      /*              */
                            unsigned char TCIEV:1;      /*    TCIEV     */
                            unsigned char TGIED:1;      /*    TGIED     */
                            unsigned char TGIEC:1;      /*    TGIEC     */
                            unsigned char TGIEB:1;      /*    TGIEB     */
                            unsigned char TGIEA:1;      /*    TGIEA     */
                            }      Bit;                 /*              */
                     }          TIER;                   /*              */
               union {                                  /* TSR          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :3;       /*              */
                            unsigned char TCFV:1;       /*    TCFV      */
                            unsigned char TGFD:1;       /*    TGFD      */
                            unsigned char TGFC:1;       /*    TGFC      */
                            unsigned char TGFB:1;       /*    TGFB      */
                            unsigned char TGFA:1;       /*    TGFA      */
                            }      Bit;                 /*              */
                     }          TSR;                    /*              */
               unsigned int     TCNT;                   /* TCNT         */
               unsigned int     TGRA;                   /* TGRA         */
               unsigned int     TGRB;                   /* TGRB         */
               unsigned int     TGRC;                   /* TGRC         */
               unsigned int     TGRD;                   /* TGRD         */
};                                                      /*              */
struct st_tpu1 {                                        /* struct TPU1  */
               union {                                  /* TCR          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char CCLR:2;       /*    CCLR      */
                            unsigned char CKEG:2;       /*    CKEG      */
                            unsigned char TPSC:3;       /*    TPSC      */
                            }      Bit;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TMDR         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk :4;        /*              */
                            unsigned char MD :4;        /*    MD        */
                            }      Bit;                 /*              */
                     }          TMDR;                   /*              */
               union {                                  /* TIOR         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char IOB:4;        /*    IOB       */
                            unsigned char IOA:4;        /*    IOA       */
                            }      Bit;                 /*              */
                     }          TIOR;                   /*              */
               char             wk;                     /*              */
               union {                                  /* TIER         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TTGE :1;      /*    TTGE      */
                            unsigned char      :1;      /*              */
                            unsigned char TCIEU:1;      /*    TCIEU     */
                            unsigned char TCIEV:1;      /*    TCIEV     */
                            unsigned char      :2;      /*              */
                            unsigned char TGIEB:1;      /*    TGIEB     */
                            unsigned char TGIEA:1;      /*    TGIEA     */
                            }      Bit;                 /*              */
                     }          TIER;                   /*              */
               union {                                  /* TSR          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TCFD:1;       /*    TCFD      */
                            unsigned char     :1;       /*              */
                            unsigned char TCFU:1;       /*    TCFU      */
                            unsigned char TCFV:1;       /*    TCFV      */
                            unsigned char     :2;       /*              */
                            unsigned char TGFB:1;       /*    TGFB      */
                            unsigned char TGFA:1;       /*    TGFA      */
                            }      Bit;                 /*              */
                     }          TSR;                    /*              */
               unsigned int     TCNT;                   /* TCNT         */
               unsigned int     TGRA;                   /* TGRA         */
               unsigned int     TGRB;                   /* TGRB         */
};                                                      /*              */
struct st_intc {                                        /* struct INTC  */
               union {                                  /* ISCR         */
                     unsigned int Word;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char H;            /*    ISCRH     */
                            unsigned char L;            /*    ISCRL     */
                            }     Byte;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char wk    :4;     /*              */
                            unsigned char IRQ5SC:2;     /*    IRQ5SC    */
                            unsigned char IRQ4SC:2;     /*    IRQ4SC    */
                            unsigned char IRQ3SC:2;     /*    IRQ3SC    */
                            unsigned char IRQ2SC:2;     /*    IRQ2SC    */
                            unsigned char IRQ1SC:2;     /*    IRQ1SC    */
                            unsigned char IRQ0SC:2;     /*    IRQ0SC    */
                            }     Bit;                  /*              */
                     }          ISCR;                   /*              */
               union {                                  /* IER          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk   :2;      /*              */
                            unsigned char IRQ5E:1;      /*    IRQ5E     */
                            unsigned char IRQ4E:1;      /*    IRQ4E     */
                            unsigned char IRQ3E:1;      /*    IRQ3E     */
                            unsigned char IRQ2E:1;      /*    IRQ2E     */
                            unsigned char IRQ1E:1;      /*    IRQ1E     */
                            unsigned char IRQ0E:1;      /*    IRQ0E     */
                            }      Bit;                 /*              */
                     }          IER;                    /*              */
               union {                                  /* ISR          */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk   :2;      /*              */
                            unsigned char IRQ5F:1;      /*    IRQ5F     */
                            unsigned char IRQ4F:1;      /*    IRQ4F     */
                            unsigned char IRQ3F:1;      /*    IRQ3F     */
                            unsigned char IRQ2F:1;      /*    IRQ2F     */
                            unsigned char IRQ1F:1;      /*    IRQ1F     */
                            unsigned char IRQ0F:1;      /*    IRQ0F     */
                            }      Bit;                 /*              */
                     }          ISR;                    /*              */
               char             wk1[170];               /*              */
               union {                                  /* IPRA         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char HIGH:3;       /*    IRQ0      */
                            unsigned char     :1;       /*              */
                            unsigned char LOW :3;       /*    IRQ1      */
                            }      Bit;                 /*              */
                     }          IPRA;                   /*              */
               union {                                  /* IPRB         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char HIGH:3;       /*    IRQ2,3    */
                            unsigned char     :1;       /*              */
                            unsigned char LOW :3;       /*    IRQ4,5    */
                            }      Bit;                 /*              */
                     }          IPRB;                   /*              */
               union {                                  /* IPRC         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :5;       /*              */
                            unsigned char LOW :3;       /*    DTC       */
                            }      Bit;                 /*              */
                     }          IPRC;                   /*              */
               union {                                  /* IPRD         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char HIGH:3;       /*    WDT0      */
                            }      Bit;                 /*              */
                     }          IPRD;                   /*              */
               union {                                  /* IPRE         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char HIGH:3;       /*    PBC       */
                            unsigned char     :1;       /*              */
                            unsigned char LOW :3;       /*    A/D,WDT1  */
                            }      Bit;                 /*              */
                     }          IPRE;                   /*              */
               union {                                  /* IPRF         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char HIGH:3;       /*    TPU0      */
                            unsigned char     :1;       /*              */
                            unsigned char LOW :3;       /*    TPU1      */
                            }      Bit;                 /*              */
                     }          IPRF;                   /*              */
               union {                                  /* IPRG         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char HIGH:3;       /*    TPU2      */
                            unsigned char     :1;       /*              */
                            unsigned char LOW :3;       /*    TPU3      */
                            }      Bit;                 /*              */
                     }          IPRG;                   /*              */
               union {                                  /* IPRH         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char HIGH:3;       /*    TPU4      */
                            unsigned char     :1;       /*              */
                            unsigned char LOW :3;       /*    TPU5      */
                            }      Bit;                 /*              */
                     }          IPRH;                   /*              */
               char             wk2;                    /*              */
               union {                                  /* IPRJ         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :5;       /*              */
                            unsigned char LOW :3;       /*    SCI0      */
                            }      Bit;                 /*              */
                     }          IPRJ;                   /*              */
               union {                                  /* IPRK         */
                     unsigned char Byte;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char wk  :1;       /*              */
                            unsigned char HIGH:3;       /*    SCI1      */
                            unsigned char     :1;       /*              */
                            unsigned char LOW :3;       /*    SCI2      */
                            }      Bit;                 /*              */
                     }          IPRK;                   /*              */
};                                                      /*              */
struct st_bsc {                                         /* struct BSC   */
              char              wk1;                    /*              */
              union {                                   /* PFCR         */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk :4;         /*              */
                           unsigned char AE3:1;         /*    AE3       */
                           unsigned char AE2:1;         /*    AE2       */
                           unsigned char AE1:1;         /*    AE1       */
                           unsigned char AE0:1;         /*    AE0       */
                           }      Bit;                  /*              */
                    }           PFCR;                   /*              */
              char              wk2[228];               /*              */
              union {                                   /* ABWCR        */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B7:1;          /*    Bit 7     */
                           unsigned char B6:1;          /*    Bit 6     */
                           unsigned char B5:1;          /*    Bit 5     */
                           unsigned char B4:1;          /*    Bit 4     */
                           unsigned char B3:1;          /*    Bit 3     */
                           unsigned char B2:1;          /*    Bit 2     */
                           unsigned char B1:1;          /*    Bit 1     */
                           unsigned char B0:1;          /*    Bit 0     */
                           }      Bit;                  /*              */
                    }           ABWCR;                  /*              */
              union {                                   /* ASTCR        */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B7:1;          /*    Bit 7     */
                           unsigned char B6:1;          /*    Bit 6     */
                           unsigned char B5:1;          /*    Bit 5     */
                           unsigned char B4:1;          /*    Bit 4     */
                           unsigned char B3:1;          /*    Bit 3     */
                           unsigned char B2:1;          /*    Bit 2     */
                           unsigned char B1:1;          /*    Bit 1     */
                           unsigned char B0:1;          /*    Bit 0     */
                           }      Bit;                  /*              */
                    }           ASTCR;                  /*              */
              union {                                   /* WCR          */
                    unsigned int Word;                  /*  Word Access */
                    struct {                            /*  Byte Access */
                           unsigned char H;             /*    WCRH      */
                           unsigned char L;             /*    WCRL      */
                           }     Byte;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char W7:2;          /*    W7        */
                           unsigned char W6:2;          /*    W6        */
                           unsigned char W5:2;          /*    W5        */
                           unsigned char W4:2;          /*    W4        */
                           unsigned char W3:2;          /*    W3        */
                           unsigned char W2:2;          /*    W2        */
                           unsigned char W1:2;          /*    W1        */
                           unsigned char W0:2;          /*    W0        */
                           }     Bit;                   /*              */
                    }           WCR;                    /*              */
              union {                                   /* BCR          */
                    unsigned int Word;                  /*  Word Access */
                    struct {                            /*  Byte Access */
                           unsigned char H;             /*    BCRH      */
                           unsigned char L;             /*    BCRL      */
                           }     Byte;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char ICIS1 :1;      /*    ICIS1     */
                           unsigned char ICIS0 :1;      /*    ICIS0     */
                           unsigned char BRSTRM:1;      /*    BRSTRM    */
                           unsigned char BRSTS1:1;      /*    BRSTS1    */
                           unsigned char BRSTS0:1;      /*    BRSTS0    */
                           unsigned char       :3;      /*              */
                           unsigned char BRLE  :1;      /*    BRLE      */
                           unsigned char BREQOE:1;      /*    BREQOE    */
                           unsigned char       :4;      /*              */
                           unsigned char WDBE  :1;      /*    WDBE      */
                           unsigned char WAITE :1;      /*    WAITE     */
                           }     Bit;                   /*              */
                    }           BCR;                    /*              */
};                                                      /*              */
struct st_sci {                                         /* struct SCI   */
              union {                                   /* SMR          */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CA  :1;        /*    C/A       */
                           unsigned char CHR :1;        /*    CHR       */
                           unsigned char PE  :1;        /*    PE        */
                           unsigned char OE  :1;        /*    O/E       */
                           unsigned char STOP:1;        /*    STOP      */
                           unsigned char MP  :1;        /*    MP        */
                           unsigned char CKS :2;        /*    CKS       */
                           }      Bit;                  /*              */
                    }           SMR;                    /*              */
              unsigned char     BRR;                    /* BRR          */
              union {                                   /* SCR          */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TIE :1;        /*    TIE       */
                           unsigned char RIE :1;        /*    RIE       */
                           unsigned char TE  :1;        /*    TE        */
                           unsigned char RE  :1;        /*    RE        */
                           unsigned char MPIE:1;        /*    MPIE      */
                           unsigned char TEIE:1;        /*    TEIE      */
                           unsigned char CKE :2;        /*    CKE       */
                           }      Bit;                  /*              */
                    }           SCR;                    /*              */
              unsigned char     TDR;                    /* TDR          */
              union {                                   /* SSR          */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TDRE:1;        /*    TDRE      */
                           unsigned char RDRF:1;        /*    RDRF      */
                           unsigned char ORER:1;        /*    ORER      */
                           unsigned char FER :1;        /*    FER       */
                           unsigned char PER :1;        /*    PER       */
                           unsigned char TEND:1;        /*    TEND      */
                           unsigned char MPB :1;        /*    MPB       */
                           unsigned char MPBT:1;        /*    MPBT      */
                           }      Bit;                  /*              */
                    }           SSR;                    /*              */
              unsigned char     RDR;                    /* RDR          */
              union {                                   /* SCMR         */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk  :4;        /*              */
                           unsigned char SDIR:1;        /*    SDIR      */
                           unsigned char SINV:1;        /*    SINV      */
                           unsigned char     :1;        /*              */
                           unsigned char SMIF:1;        /*    SMIF      */
                           }      Bit;                  /*              */
                    }           SCMR;                   /*              */
              char              wk;                     /*              */
};                                                      /*              */
struct st_ici {                                         /* struct ICI   */
              union {                                   /* SMR          */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char GM  :1;        /*    GM        */
                           unsigned char BLK :1;        /*    BLK       */
                           unsigned char PE  :1;        /*    PE        */
                           unsigned char OE  :1;        /*    O/E       */
                           unsigned char BCP :2;        /*    BCP       */
                           unsigned char CKS :2;        /*    CKS       */
                           }      Bit;                  /*              */
                    }           SMR;                    /*              */
              unsigned char     BRR;                    /* BRR          */
              union {                                   /* SCR          */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TIE :1;        /*    TIE       */
                           unsigned char RIE :1;        /*    RIE       */
                           unsigned char TE  :1;        /*    TE        */
                           unsigned char RE  :1;        /*    RE        */
                           unsigned char MPIE:1;        /*    MPIE      */
                           unsigned char TEIE:1;        /*    TEIE      */
                           unsigned char CKE :2;        /*    CKE       */
                           }      Bit;                  /*              */
                    }           SCR;                    /*              */
              unsigned char     TDR;                    /* TDR          */
              union {                                   /* SSR          */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TDRE:1;        /*    TDRE      */
                           unsigned char RDRF:1;        /*    RDRF      */
                           unsigned char ORER:1;        /*    ORER      */
                           unsigned char ERS :1;        /*    ERS       */
                           unsigned char PER :1;        /*    PER       */
                           unsigned char TEND:1;        /*    TEND      */
                           unsigned char MPB :1;        /*    MPB       */
                           unsigned char MPBT:1;        /*    MPBT      */
                           }      Bit;                  /*              */
                    }           SSR;                    /*              */
              unsigned char     RDR;                    /* RDR          */
              union {                                   /* SCMR         */
                    unsigned char Byte;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char wk  :4;        /*              */
                           unsigned char SDIR:1;        /*    SDIR      */
                           unsigned char SINV:1;        /*    SINV      */
                           unsigned char     :1;        /*              */
                           unsigned char SMIF:1;        /*    SMIF      */
                           }      Bit;                  /*              */
                    }           SCMR;                   /*              */
              char              wk;                     /*              */
};                                                      /*              */
struct st_ad {                                          /* struct A/D   */
             unsigned int       DRA;                    /* ADDRA        */
             unsigned int       DRB;                    /* ADDRB        */
             unsigned int       DRC;                    /* ADDRC        */
             unsigned int       DRD;                    /* ADDRD        */
             union {                                    /* ADCSR        */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char ADF :1;         /*    ADF       */
                          unsigned char ADIE:1;         /*    ADIE      */
                          unsigned char ADST:1;         /*    ADST      */
                          unsigned char SCAN:1;         /*    SCAN      */
                          unsigned char CH  :4;         /*    CH        */
                          }      Bit;                   /*              */
                   }            CSR;                    /*              */
             union {                                    /* ADCR         */
                   unsigned char Byte;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char TRGS:2;         /*    TRGS      */
                          unsigned char     :2;         /*              */
                          unsigned char CKS :2;         /*    CKS       */
                          }      Bit;                   /*              */
                   }            CR;                     /*              */
};                                                      /*              */
struct st_flash {                                       /* struct FLASH */
                union {                                 /* RAMER        */
                      unsigned char Byte;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char wk  :4;      /*              */
                             unsigned char RAMS:1;      /*    RAMS      */
                             unsigned char RAM2:1;      /*    RAM2      */
                             unsigned char RAM1:1;      /*    RAM1      */
                             unsigned char RAM0:1;      /*    RAM0      */
                             }      Bit;                /*              */
                      }         RAMER;                  /*              */
                char            wk[204];                /*              */
                union {                                 /* FLMCR1       */
                      unsigned char Byte;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char FWE :1;      /*    FWE       */
                             unsigned char SWE1:1;      /*    SWE1      */
                             unsigned char ESU1:1;      /*    ESU1      */
                             unsigned char PSU1:1;      /*    PSU1      */
                             unsigned char EV1 :1;      /*    EV1       */
                             unsigned char PV1 :1;      /*    PV1       */
                             unsigned char E1  :1;      /*    E1        */
                             unsigned char P1  :1;      /*    P1        */
                             }      Bit;                /*              */
                      }         FLMCR1;                 /*              */
                union {                                 /* FLMCR2       */
                      unsigned char Byte;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char FLER:1;      /*    FLER      */
                             }      Bit;                /*              */
                      }         FLMCR2;                 /*              */
                union {                                 /* EBR1         */
                      unsigned char Byte;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char EB7:1;       /*    EB7       */
                             unsigned char EB6:1;       /*    EB6       */
                             unsigned char EB5:1;       /*    EB5       */
                             unsigned char EB4:1;       /*    EB4       */
                             unsigned char EB3:1;       /*    EB3       */
                             unsigned char EB2:1;       /*    EB2       */
                             unsigned char EB1:1;       /*    EB1       */
                             unsigned char EB0:1;       /*    EB0       */
                             }      Bit;                /*              */
                      }         EBR1;                   /*              */
                union {                                 /* EBR2         */
                      unsigned char Byte;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char wk  :4;      /*              */
                             unsigned char EB11:1;      /*    EB11      */
                             unsigned char EB10:1;      /*    EB10      */
                             unsigned char EB9 :1;      /*    EB9       */
                             unsigned char EB8 :1;      /*    EB8       */
                             }      Bit;                /*              */
                      }         EBR2;                   /*              */
                union {                                 /* FLPWCR       */
                      unsigned char Byte;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char PDWND:1;     /*    PDWND     */
                             }      Bit;                /*              */
                      }         FLPWCR;                 /*              */
};                                                      /*              */
#define HCAN    (*(volatile struct st_hcan  *)0xFFF800) /* HCAN  Address*/
#define SCRX    (*(volatile union  un_scrx  *)0xFFFDB4) /* SCRX  Address*/
#define SBYCR   (*(volatile union  un_sbycr *)0xFFFDE4) /* SBYCR Address*/
#define SYSCR   (*(volatile union  un_syscr *)0xFFFDE5) /* SYSCR Address*/
#define SCKCR   (*(volatile union  un_sckcr *)0xFFFDE6) /* SCKCR Address*/
#define MDCR    (*(volatile union  un_mdcr  *)0xFFFDE7) /* MDCR  Address*/
#define MSTP    (*(volatile struct st_mstp  *)0xFFFDE8) /* MSTP  Address*/
#define LPWRCR  (*(volatile union  un_lpwrcr*)0xFFFDEC) /* LPWRCRAddress*/
#define PBC     (*(volatile struct st_pbc   *)0xFFFE00) /* PBC   Address*/
#define DTC     (*(volatile struct st_dtc   *)0xFFFE16) /* DTC   Address*/
#define PPG     (*(volatile struct st_ppg   *)0xFFFE26) /* PPG   Address*/
#define P1      (*(volatile struct st_p1    *)0xFFFE30) /* P1    Address*/
#define P4      (*(volatile struct st_p4    *)0xFFFFB3) /* P4    Address*/
#define P9      (*(volatile struct st_p4    *)0xFFFFB8) /* P9    Address*/
#define PA      (*(volatile struct st_pa    *)0xFFFE39) /* PA    Address*/
#define PB      (*(volatile struct st_pb    *)0xFFFE3A) /* PB    Address*/
#define PC      (*(volatile struct st_pb    *)0xFFFE3B) /* PC    Address*/
#define PD      (*(volatile struct st_pd    *)0xFFFE3C) /* PD    Address*/
#define PE      (*(volatile struct st_pd    *)0xFFFE3D) /* PE    Address*/
#define PF      (*(volatile struct st_p1    *)0xFFFE3E) /* PF    Address*/
#define TPU     (*(volatile struct st_tpu   *)0xFFFEB0) /* TPU   Address*/
#define TPU0    (*(volatile struct st_tpu0  *)0xFFFF10) /* TPU0  Address*/
#define TPU1    (*(volatile struct st_tpu1  *)0xFFFF20) /* TPU1  Address*/
#define TPU2    (*(volatile struct st_tpu1  *)0xFFFF30) /* TPU2  Address*/
#define TPU3    (*(volatile struct st_tpu0  *)0xFFFE80) /* TPU3  Address*/
#define TPU4    (*(volatile struct st_tpu1  *)0xFFFE90) /* TPU4  Address*/
#define TPU5    (*(volatile struct st_tpu1  *)0xFFFEA0) /* TPU5  Address*/
#define INTC    (*(volatile struct st_intc  *)0xFFFE12) /* INTC  Address*/
#define BSC     (*(volatile struct st_bsc   *)0xFFFDEA) /* BSC   Address*/
#define SCI0    (*(volatile struct st_sci   *)0xFFFF78) /* SCI0  Address*/
#define SCI1    (*(volatile struct st_sci   *)0xFFFF80) /* SCI1  Address*/
#define SCI2    (*(volatile struct st_sci   *)0xFFFF88) /* SCI2  Address*/
#define ICI0    (*(volatile struct st_ici   *)0xFFFF78) /* ICI0  Address*/
#define ICI1    (*(volatile struct st_ici   *)0xFFFF80) /* ICI1  Address*/
#define ICI2    (*(volatile struct st_ici   *)0xFFFF88) /* ICI2  Address*/
#define AD      (*(volatile struct st_ad    *)0xFFFF90) /* A/D   Address*/
#define FLASH   (*(volatile struct st_flash *)0xFFFEDB) /* FLASH Address*/
#define st_tpu3 st_tpu0                         /* Change Struct TPU3   */
#define st_tpu2 st_tpu1                         /* Change Struct TPU2   */
#define st_tpu4 st_tpu1                         /* Change Struct TPU4   */
#define st_tpu5 st_tpu1                         /* Change Struct TPU5   */
#define st_p9   st_p4                           /* Change Struct P9->P4 */
#define st_pc   st_pb                           /* Change Struct PC->PB */
#define st_pe   st_pd                           /* Change Struct PE->PD */
#define st_pf   st_p1                           /* Change Struct PF->P1 */


#endif   /* _H8S2623F_H_ */

