#ifndef __H8_SYSMAC_H__
#define __H8_SYSMAC_H__

#define stringer(str) 	#str

#define IsPortBit(_port, _bit)            ((_port)&(1<<(_bit)))

#define Us2DelayClock(us)	(CLOCK_FRQ/1000000UL*us/4)

static inline void DelayUs(unsigned long _clock)
{
 asm ("\n"
"#ifndef __DELAY_MACRO_DEFINED__	\n"
"#define __DELAY_MACRO_DEFINED__	\n"
".macro  delayMacro countReg		\n"
".Ldelay\\@:						\n"
"		nop							\n"
"		dec.l #1,\\countReg			\n"	  //loop is 4 clocks
"		bne .Ldelay\\@:8			\n"	  //
".endm								\n"
"#endif								\n"
"	delayMacro	%0					\n"
 :
 :"r"(_clock)
 );
}

#define CpuUnlock()     asm( "andc #0x7f, ccr" )       
#define CpuLock()       asm( "orc  #0x80, ccr" )

typedef unsigned char CpuStatus;

   /* Save & disable interrupt */
#define CpuSaveAndLock(p_cpu_status) do { \
	register unsigned int __ccr__; \
   asm( "stc.b  ccr, %0l\n\t mov.b %0l, %0l" : "=r" (__ccr__)); \
   *(&cpu_status) =	__ccr__; \
   asm( "orc  #0x80, ccr" ); \
   } while(0)
   
   /* Restore interrupt */
#define CpuRestoreLock(cpu_status) do { \
   register unsigned char __ccr__ = cpu_status; \
   asm( "ldc.b %0l, ccr" : : "r" (__ccr__) ); \
   } while(0)

   /* Test disable interrupt */
#define IsCpuLock() ({ \
	register unsigned char __ccr__; \
   asm( "stc.b  ccr, %0l" : "=r" (__ccr__)); \
   (__ccr__ & 0x80 ) != 0; \
   })

#define CpuNop()        asm( "nop" )
#define Trap1()         asm( "trapa #0" )
#define Trap2()         asm( "trapa #1" )
#define Trap3()         asm( "trapa #2" )
#define Trap4()         asm( "trapa #3" )

#define LowByte(_word) (*((char*)&(_word)+1))
#define HiByte(_word)  (*((char*)&(_word)))

#define CpuSetIntLevel(level)   asm("ldc %0,exr"::"g"(level))

static inline long swap_l(long l)
{
 register long tmp;
 asm("	mov.l     %S0,%S1	\n"
	 "	mov.b     %s0,%t0	\n"
	 "	mov.b     %t1,%s0	\n"
	 "	mov.w     %f0,%e0	\n"
	 "	mov.w     %e1,%f1	\n"
	 "	mov.b     %t1,%s0	\n"
	 "	mov.b     %s1,%t0	\n"
	:"=r"(l),"=r"(tmp):"0"(l));
 return l;
}

static inline short int swap_w(short int w)
{
 register short int tmp;
 asm("	mov.w     %f0,%f1	\n"
	 "	mov.b     %s0,%t0	\n"
	 "	mov.b     %t1,%s0	\n"
	:"=r"(w),"=r"(tmp):"0"(w));
 return w;
}



#endif //__H8_SYSMAC_H__
