BINDIR  = 
INCDIR  = 
LIBDIR  = 

BLDDIR=debug
TARGET_CHIP=h8300s
all :
	echo All Done 
LIST=1

PROJ    = test
PROJDIR = ./

OPT_CFG = -ms -ms2600
OPT_CMN = -gcoff3 -Wa,--listing-lhs-width=2,--listing-rhs-width=80,--listing-cont-lines=65 -Wlist=lchmd
OPT_CP  = -fno-exceptions -fno-rtti -fsigned-char -fsigned-bitfields -Wall
OPT_AS  = 
OPT_LK  = -Wl,--oformat=coff-h8300

all : $(PROJ).out

lm87.o : lm87.cpp
	@echo Compiling $(subst \,/,$<)
        ifeq ($(LIST),1)
		-cp $(subst \,/,$<) .
		-@$(subst \,/,h8300-hms-g++.exe) -MD -pipe -c $(OPT_CFG) $(subst \,/,$(OPT_CP))\
		$(patsubst -Wlist=%,,$(subst \,/,$(OPT_CMN))) \
		"-Wa,-a$(subst -Wlist=,,$(filter -Wlist=%,$(subst \,/,$(OPT_CMN))))=./lst/$(notdir $(subst \,/,$<)).lst" \
		-I"$(dir $(subst \,/,$<))" \
		"$(subst \,/,$<)" \
		-I"$(subst \,/,$(PROJDIR))"
		-rm $(notdir $(subst \,/,$<))
         else
		-@$(subst \,/,h8300-hms-g++.exe) -MD -pipe -c \
		$(OPT_CFG) $(subst \,/,$(OPT_CP)) $(subst \,/,$(OPT_CMN))\
		-I"$(dir $(subst \,/,$<))" \
		"$(subst \,/,$<)" \
		-I"$(subst \,/,$(PROJDIR))"
        endif

main.o : main.cpp
	@echo Compiling $(subst \,/,$<)
        ifeq ($(LIST),1)
		-cp $(subst \,/,$<) .
		-@$(subst \,/,h8300-hms-g++.exe) -MD -pipe -c $(OPT_CFG) $(subst \,/,$(OPT_CP))\
		$(patsubst -Wlist=%,,$(subst \,/,$(OPT_CMN))) \
		"-Wa,-a$(subst -Wlist=,,$(filter -Wlist=%,$(subst \,/,$(OPT_CMN))))=./lst/$(notdir $(subst \,/,$<)).lst" \
		-I"$(dir $(subst \,/,$<))" \
		"$(subst \,/,$<)" \
		-I"$(subst \,/,$(PROJDIR))"
		-rm $(notdir $(subst \,/,$<))
         else
		-@$(subst \,/,h8300-hms-g++.exe) -MD -pipe -c \
		$(OPT_CFG) $(subst \,/,$(OPT_CP)) $(subst \,/,$(OPT_CMN))\
		-I"$(dir $(subst \,/,$<))" \
		"$(subst \,/,$<)" \
		-I"$(subst \,/,$(PROJDIR))"
        endif

uart.o : uart.cpp
	@echo Compiling $(subst \,/,$<)
        ifeq ($(LIST),1)
		-cp $(subst \,/,$<) .
		-@$(subst \,/,h8300-hms-g++.exe) -MD -pipe -c $(OPT_CFG) $(subst \,/,$(OPT_CP))\
		$(patsubst -Wlist=%,,$(subst \,/,$(OPT_CMN))) \
		"-Wa,-a$(subst -Wlist=,,$(filter -Wlist=%,$(subst \,/,$(OPT_CMN))))=./lst/$(notdir $(subst \,/,$<)).lst" \
		-I"$(dir $(subst \,/,$<))" \
		"$(subst \,/,$<)" \
		-I"$(subst \,/,$(PROJDIR))"
		-rm $(notdir $(subst \,/,$<))
         else
		-@$(subst \,/,h8300-hms-g++.exe) -MD -pipe -c \
		$(OPT_CFG) $(subst \,/,$(OPT_CP)) $(subst \,/,$(OPT_CMN))\
		-I"$(dir $(subst \,/,$<))" \
		"$(subst \,/,$<)" \
		-I"$(subst \,/,$(PROJDIR))"
        endif

$(PROJ).out : lm87.o main.o uart.o
	@echo Creating COFF file $@
	$(subst \,/,h8300-hms-gcc.exe) \
	$(OPT_CFG) $(subst \,/,$(OPT_CMN)) \
	$(filter-out %.a,$(filter-out $(subst \,/,$(LNK_SCRIPT)),$(subst \,/,$^))) \
	$(filter %.a,$(filter-out $(subst \,/,$(LNK_SCRIPT)),$(subst \,/,$^))) \
	$(addprefix -L,$(dir $(filter %.a,$(filter-out $(subst \,/,$(LNK_SCRIPT)),$(subst \,/,$^))))) \
	-o "$(subst \,/,$@)" $(subst \,/,$(OPT_LK))
	$(subst \,/,h8300-hms-objcopy.exe) -O srec "$(subst \,/,$@)" "$(PROJ).rec"

$(PROJ).out : $(subst \,/,$(LNK_SCRIPT))

ifneq (0,${MAKELEVEL})
include $(wildcard *.d)
endif
ifeq (0,${MAKELEVEL})
SRC_DIR   := ./ ../ $(PROJDIR) $(INCDIR) $(LIBDIR)
endif
.PHONY: clean build rebuild
rebuild :
	-mkdir ./$(BLDDIR) ./$(BLDDIR)/lst 2> nul
	$(MAKE) VPATH="$(subst \,/,$(SRC_DIR))" -C ./$(BLDDIR) -f ../$(PROJ).mak clean all
build:
	-mkdir ./$(BLDDIR) ./$(BLDDIR)/lst 2> nul
	$(MAKE) VPATH="$(subst \,/,$(SRC_DIR))" -C ./$(BLDDIR) -f ../$(PROJ).mak all
clean:
	-rm *.o *.d $(PROJ).* ./lst/*.lst 2>nul 

