#ifndef __TPU_H__
#define __TPU_H__

#define TPU_TGR_SET( div, fout )    (CLOCK_FRQ/(long)(div)/(long)(fout) - 1)
#define TPU_TGR_SET_HZ( div, fout ) (CLOCK_FRQ/2L/(long)(div)/(long)(fout) - 1)
#define BEEPER_SET_HZ( fout )       (CLOCK_FRQ/2L/16L/(long)(fout) - 1)

#ifdef __cplusplus
extern "C" {
#endif

void Tpu0InitPWM2( void );
void Tpu4InitNormal( void );
void Tpu5InitNormal( void );
void Tpu1InitNormal( void );
void Tpu2InitNormal( void );

/*---------------------------------------------------------------------------*/

static inline void TpuStart( BYTE channel )
{
 if(channel<=5)
	TPU.TSTR.Byte|=1<<channel;
}

/*---------------------------------------------------------------------------*/

static inline void TpuStop( BYTE channel )
{
 if(channel<=5)
	TPU.TSTR.Byte&=~(1<<channel);
}

#ifdef __cplusplus
}
#endif

#define SetPWM_0(_val)  TPU0.TGRA=_val
#define SetPWM_1(_val)  TPU0.TGRB=_val
#define SetPWM_2(_val)  TPU0.TGRC=_val
#define SetPWM_3(_val)  TPU0.TGRD=_val

#endif //__TPU_H__

