#ifndef __UART2_H__
#define __UART2_H__

#include <uart.h>

class Uart2:public Uart<Uart2>
{
 public:
	Uart2() 
	{
	  using namespace sci_cfg;

	  SCI2.SMR.Byte = MODE(async)|CHAR_LEN(8)|PARITY(even)|STOP(1);
	  SCI2.BRR = BAUD(CLOCK_FRQ,0,38400UL);	//38400 for 16 MHz
	  SCI2.SCR.Byte = TX(1)|RX(1)|SCLK_PIN(SCK_IO);
	  SCI2.SSR.Byte = 0x80;
	  RxUnlock();
	};

	void enable()  {MSTP.CRB.Bit.DisableSCI2=false;}
	void disable() {MSTP.CRB.Bit.DisableSCI2=true;}

	BYTE &Tx() 		{return (BYTE)SCI2.TDR;}
	void TxLock()   {SCI2.SCR.Bit.TIE=0;};
	void TxUnlock() {SCI2.SCR.Bit.TIE=1;};
	bool TxEmpty()  {return SCI2.SSR.Bit.TDRE;}

	void RxLock()   {SCI2.SCR.Bit.RIE=0;};
	void RxUnlock() {SCI2.SCR.Bit.RIE=1;};
	BYTE &Rx() 		{return (BYTE)SCI2.RDR;}

	void ErrLock()   {SCI2.SCR.Bit.TEIE=0;}
	void ErrUnlock() {SCI2.SCR.Bit.TEIE=1;}

	BYTE getErr()	{return SCI2.SMR.Byte;};
 protected:
	static void OnTransmit() asm("__Interrupt_TXI2_SCI2")  __attribute__ ((interrupt_handler));
	static void OnReceive()  asm("__Interrupt_RXI2_SCI2") __attribute__ ((interrupt_handler));
	static void OnError()    asm("__Interrupt_ERI2_SCI2") __attribute__ ((interrupt_handler));
};

#endif //__UART2_H__
